//
//  Controller.m
//  iPhoto Modified Importer
//
//  Created by Greg Kennedy on 11/17/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Controller.h"
#include "stdio.h"

extern NSString * origFilename;

FILE *fpInFile;
extern FILE *fpFile;

@implementation Controller

-(IBAction)chooseFile:(id)sender
{
	// Create the File Open Dialog class.
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];

	// Enable the selection of files in the dialog.
	[openDlg setCanChooseFiles:YES];

	// Enable the selection of directories in the dialog.
	[openDlg setCanChooseDirectories:NO];

	// Enable the selection of files in the dialog.
	[openDlg setAllowsMultipleSelection:NO];

	// Display the dialog.  If the OK button was pressed,
	// process the files.
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		// Get an array containing the full filenames of all
		// files and directories selected.
		NSArray* files = [openDlg filenames];
		
		// Loop through all the files and process them.
		for( int i = 0; i < [files count]; i++ )
		{
			NSString* fileName = [files objectAtIndex:i];
			
			// Do something with the filename.
			[txtModifyFile setStringValue:fileName];
		}
	}
}

-(IBAction)chooseDirectory:(id)sender
{
	// Create the File Open Dialog class.
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];
	
	// DISable the selection of files in the dialog.
	[openDlg setCanChooseFiles:NO];

	// Enable the selection of directories in the dialog.
	[openDlg setCanChooseDirectories:YES];

	// Enable the selection of files in the dialog.
	[openDlg setAllowsMultipleSelection:NO];

	// Display the dialog.  If the OK button was pressed,
	// process the files.
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		// Get an array containing the full filenames of all
		// files and directories selected.
		NSArray* urls = [openDlg URLs];
		
		// Loop through all the files and process them.
		for( int i = 0; i < [urls count]; i++ )
		{
			NSURL* url = [urls objectAtIndex:i];
			
			// Do something with the filename.
			[navBrowser setURL:url];
		}
	}
}

-(IBAction)saveFile:(id)sender
{
	long lSize;
	char *buffer;
	size_t result;
	
	fpInFile = fopen([[txtModifyFile stringValue] UTF8String],"rb");
	if (fpInFile != NULL)
	{
		fseek(fpInFile,0,SEEK_END);
		lSize = ftell(fpInFile);
		rewind(fpInFile);

		// allocate memory to contain the whole file:
		buffer = (char*) malloc (sizeof(char)*lSize);
		if (buffer == NULL) {fputs ("Memory error",stderr); exit (2);}
		// copy the file into the buffer:
		result = fread (buffer,1,lSize,fpInFile);
		if (result != lSize) {fputs ("Reading error",stderr); exit (3);}
		// copy the file into the buffer:
		result = fwrite (buffer,1,lSize,fpFile);
		if (result != lSize) {fputs ("Writing error",stderr); exit (4);}
		free(buffer);
	}
	fclose(fpInFile);
	fclose(fpFile);
	
	[NSApp performSelector:@selector(terminate:) withObject:nil afterDelay:0.0];
}

@end
